=== added file 'doc/README.1st'
--- doc/README.1st	1970-01-01 00:00:00 +0000
+++ doc/README.1st	2006-03-14 16:22:52 +0000
@@ -0,0 +1,30 @@
+These documents originally came from the Bazaar-NG wiki hosted at
+http://bazaar-vcs.org. These documents, though maintained, These documenets
+can fall behind when Bazaar-NG is under heavy development.
+
+The documents on the wiki take precedence in the event of a discrepancy
+between what is documented here and what is documented on the wiki.
+
+README.1st::
+    You've already read this, right?
+
+tutorial.txt::
+    Explains how to use bzr. Loaded with examples.
+
+configuration.txt::
+    Information on how to configure Bazaar-NG
+
+setting_up_email.txt::
+    The various ways that exist to tell Bazaar-NG your email address for
+    commits
+
+plugins.txt::
+    Information on how to use plugins in Bazaar-NG
+
+specifying_revisions.txt::
+    Description of the subarguments for -r as used by commands such as
+    **bzr log** and **bzr merge**
+
+using_aliases.txt::
+    How to setup and use command aliases.
+

=== added file 'doc/configuration.txt'
--- doc/configuration.txt	1970-01-01 00:00:00 +0000
+++ doc/configuration.txt	2006-03-14 16:22:52 +0000
@@ -0,0 +1,147 @@
+Location of configuration file
+==============================
+Each user gets a pair of configurations files in $HOME/.bazaar. The first
+one, named bazaar.conf, includes default configuration options. The other
+file, branches.conf, contains configuration information for specific
+branches.
+
+General Format
+==============
+An ini file has three types of contructs: section headers, section
+variables and comments.
+
+comment
+-------
+A comment is any line that starts with a "#" (sometimes called a "hash
+mark", "pound sign" or "number sign"). Comment lines are ignored by
+Bazaar-NG when parsing ini files.
+
+section header
+--------------
+A section header is a word enclosed in brackets that starts at the begining
+of a line, typical section headers look like this::
+
+    [DEFAULT]
+
+The only valid section header for bazaar.conf is [DEFAULT], which is case
+senstive. The default section provides for setting variables which can be
+overridden with the branch config file.
+
+For branches.conf, the variables from the section with the longest matching
+section header are used to the exclusion of other potentially valid section
+headers. A section header uses the path for the branch as the section
+header. Some examples include::
+
+    [http://mybranches.isp.com/~jdoe/branchdir]
+    [/home/jdoe/branches/]
+
+
+
+section variables
+-----------------
+
+A section variable resides within a section. A section variable contains a
+variable name, an equals sign and a value and generally takes the following
+form::
+
+    email            = John Doe <jdoe@isp.com>
+    check_signatures = require
+
+
+The main configuration file, bazaar.conf
+----------------------------------------
+
+The main configuration file, $HOME/.bazaar/bazaar.conf, only allows one
+section called '''[DEFAULT]'''. This default section contains the default
+configuration options for all branches. The default section can be
+overriden by providing a branch specific section in branches.conf.
+
+A typical bazaar.conf section often looks like the following::
+
+    [DEFAULT]
+    email             = John Doe <jdoe@isp.com>
+    editor            = /usr/bin/vim
+    check_signatures  = check-available
+    create_signatures = when-required
+
+$HOME/.bazaar/branches.conf allows one to specify overriding settings for a
+specific branch. The format is almost identical to the default section in
+bazaar.conf with one significant change: The section header, instead of
+saying default, will be the path to a branch that you wish to override a
+value for. The ? and * wildcards are supported::
+
+    [/home/jdoe/branches/nethack]
+    email = Nethack Admin <nethack@nethack.com>
+
+    [http://hypothetical.site.com/branches/devel-branch]
+    create_signatures = always
+    check_signatures  = always
+
+    [http://bazaar-ng.org/bzr/*]
+    check_signatures  = require
+
+Common Variable options
+=======================
+
+email
+-----
+The email address to use when committing a branch. Typically takes the form
+of::
+
+    email = Full Name <account@hostname.tld>
+
+editor
+------
+The path of the editor that you wish to use if *bzr commit* is run without
+a commit log message. This setting is trumped by the environment variables
+$BZREDITOR or $EDITOR.
+
+check_signatures
+----------------
+Defines the behavior for signatures.
+
+require
+    the gnupg signature for revisions must be present and must be valid
+
+ignore
+    Do not check gnupg signatures of revisions. 
+
+check-available
+    (default) If gnupg signatures for revisions are present, check them.
+    Bazaar-NG will fail if it finds a bad signature, but will not fail if
+    no signature is present
+
+create_signatures
+-----------------
+Defines the behaviour of signing revisions. Has three possible values:
+always, never and when-requied.
+
+always
+    sign every new revision that is committed
+
+when-required
+    (default) Sign newly committed revisions only when the branch requires
+    signed revisions
+
+never
+    Refuse to sign newly committed revisions, even if the branch requires signatures
+
+recurse
+-------
+Only useful in branches.conf. Defines whether or not the configuration for
+this section applies to subdirectories:
+
+true
+    (default) This section applies to subdirectories as well
+
+false
+    This section only applies to the branch at this directory and not
+    branches 
+
+gpg_signing_command
+-------------------
+(Default: "gpg"). Which program should be used to sign and check revisions.
+example::
+
+    gpg_signing_command = /usr/bin/gnpg
+

=== added file 'doc/plugins.txt'
--- doc/plugins.txt	1970-01-01 00:00:00 +0000
+++ doc/plugins.txt	2006-03-14 16:22:52 +0000
@@ -0,0 +1,65 @@
+What is a Plugin
+================
+A plugin is an external component for Bazaar-NG that is typically made by
+third parties. A plugin is capable of augmenting Bazaar-NG by adding or
+replacing new or current functionality in Bazaar-NG. Plugins often work as
+a way for developers to test new features for Bazaar-NG prior to inclusion
+in the official codebase. Plugins can do a variety of things, including
+overriding commands, adding new commands, providing additional network
+transports, customizing log output. The sky is the limit for the
+customization that can be done through plugins.
+
+Where to find Plugins 
+=====================
+We keep our list of plugins on the http://bazaar-vcs.org/PluginRegistry page.
+
+Writing a plugin
+================
+Plugins are very similar to bzr core functionality.  They can import
+anything in bzrlib.  A plugin may simply override standard functionality,
+but most plugins supply new commands.
+
+To create a command, make a new object that derives from
+`bzrlib.commands.Command`, and name it cmd_foo, where foo is the name of
+your command.  If you create a command whose name contains an underscore,
+it will appear in the UI with the underscore turned into a hyphen.  For
+example, "cmd_baz_import" will appear as "baz-import".  For examples of how
+to write commands, please see builtins.py.
+
+Once you've created a command you must register the command with
+`bzrlib.commands.register_command(cmd_foo)`.  You must register the command
+when your file is imported, otherwise bzr will not see it.
+
+By default, bzr will scan `bzrlib/plugins` and `~/.bazaar/plugins` for
+plugins.  You can override this with `BZR_PLUGIN_PATH`.  Plugins may be
+either modules or packages.  If your plugin is a single file, you can
+structure it as a module.  If it has multiple files, or if you want to
+distribute it as a bzr branch, you should structure it as a package, i.e. a
+directory with an `__init__.py ` file.
+
+Please feel free to contribute your plugin to BzrTools, if you think it
+would be useful to other people.
+
+How to Install a plugin 
+=======================
+Installing a plugin is very easy! One can either install a plugin
+systemwide or on a user by user basis. Both methods involve create a
+"plugins" directory. Within this directory one can place plugins in
+subdirectories. For example, "plugins/bzrtools/".
+
+Two locations are currently checked; the bzrlib/plugins directory
+(typically found in /usr/lib/python2.4/site-packages/bzrlib/plugins/) and
+$HOME/.bazaar/plugins/.
+
+One can additionally override the home plugins by setting the environment
+variable BZR_PLUGIN_PATH to a directory that contains plugins. The
+installation of a plugin can be checked by running **bzr plugins** at
+any time. New commands can be seen by running **bzr help commands**.
+
+Plugins work particularly well with Bazaar-NG branches. For example, to
+install the bzrtools plugins for your main user account, one can perform
+the following:: 
+
+    bzr branch http://panoramicfeedback.com/opensource/bzr/bzrtools
+    ~/.bazaar/plugins/bzrtools
+

=== added file 'doc/setting_up_email.txt'
--- doc/setting_up_email.txt	1970-01-01 00:00:00 +0000
+++ doc/setting_up_email.txt	2006-03-14 16:22:52 +0000
@@ -0,0 +1,76 @@
+Why set up an email address with Bazaar-NG?
+===========================================
+Bazaar-NG stores the claimed email address in revisions when they're
+created, so that people can tell who commited which revisions.  Of course,
+people can change the email address claimed, so you have to trust the
+people involved.  Additionally, the email address in a revision gives
+others a way to contact the author of a revision for credit and/or blame.
+:)
+
+How to setup your email address 
+===============================
+Bazaar-NG will try to guess an email address based on your username and the
+hostname if none is set.  This will probably not be what you want, so three
+ways exist to tell Bazaar-NG what email to use::
+
+ * You can set your email in the default ini file,
+ * You can set emails per-branch in the branch specific ini file,
+ * Or your email can be set by an environmental variable.
+
+The order of precedence is::
+
+ 1. If the `$BZREMAIL` env variable is set, use it.
+ 2. If an email is set for your current branch in the `branches.conf` ini file.
+ 3. If an email is set in the `bazaar.conf` default ini file.
+ 4. If the `$EMAIL` env variable is set.
+ 5. Bazaar-NG will try to guess based on your username and the hostname.
+
+To check on what Bazaar-NG thinks your current email is, use the '''whoami'''
+("who am i?") command::
+
+    % bzr whoami
+    Joe Cool <joe@example.com>
+
+Setting email via default ini file
+==================================
+The first method is using the default ini file.  To use the default ini
+method, create the file `$HOME/.bazaar/bazaar.conf` (on Windows this is
+`%APPDATA%\bazaar\2.0\bazaar.conf`) and set an email address as shown
+below.  Please note that the word DEFAULT is case sensitive, and must be in
+upper-case.::
+
+    [DEFAULT]
+    email=Your Name <name@isp.com>
+
+
+For more information on the ini file format, see ConfiguringBzr.
+
+Setting email on a per-branch basis
+===================================
+
+The second approach is to set email on a branch by branch basis by using the
+`$HOME/.bazaar/branches.conf` ini file, thusly::
+
+    [/some/branch/location]
+    email=Your Name <name@other-isp.com>
+
+This will set your email address in the branch at `/some/branch/location`,
+overriding the default specified in the `bazaar.conf` above.
+
+Setting email via environment
+-----------------------------
+The final method Bazaar-NG will use is checking for the `$BZREMAIL` and
+`$EMAIL` environment variables.  Generally, one would use this method to
+override the email in a script context.  If you would like to set a general
+default, then please see the ini methods above.
+
+
+Concerns for spam
+=================
+Some people want to avoid sharing their email address so as not to get
+spam.  Bazaar-NG will never disclose your email address, unless you publish
+a branch or changeset in a public location.  It's recommended that you
+''do'' use a real address, so that people can contact you about your work,
+but it's not required.  You can use an address which is obfuscated, which
+bounces, or which goes through an anti-spam service such as
+`spamgourmet.com`.

=== added file 'doc/specifying_revisions.txt'
--- doc/specifying_revisions.txt	1970-01-01 00:00:00 +0000
+++ doc/specifying_revisions.txt	2006-03-14 16:22:52 +0000
@@ -0,0 +1,137 @@
+= Revision specs and ranges =
+
+`bzr` has a very expressive way to specify a revision, or a range of revisions.
+We'll take the example of the `log` command.
+
+To specify a range of revisions, use for example::
+
+    $ bzr log -r 1..4
+
+You can omit one bound like::
+
+    $ bzr log -r 1..
+    $ bzr log -r ..4
+
+Note::
+    Omitting the lower bound doesn't work on currently released versions.
+
+Other commands, like ```bzr cat``` take only one revision, not a range, like::
+
+    $ bzr cat -r 42 foo.c
+
+= Available revision specs =
+
+The revision, or the bounds of the range, can be one of::
+
+ +--------------------+------------------------------------+
+ |  argument type     | description                        |
+ +--------------------+------------------------------------+
+ | ''number''         | revision number                    |
+ +--------------------+------------------------------------+
+ | `revno:`''number'' | positive revision number           |
+ +--------------------+------------------------------------+
+ | `last:`''number''  | negative revision number           |
+ +--------------------+------------------------------------+
+ | `revid:`''guid''   | globally unique revision id        |
+ +--------------------+------------------------------------+
+ | `before:`''rev''   | leftmost parent of ''rev''         |
+ +--------------------+------------------------------------+
+ | `date:`''value''   | first entry after a given date     |
+ +--------------------+------------------------------------+
+ | `ancestor:`''path''| last merged revision from a branch |
+ +--------------------+------------------------------------+
+ | `branch:`''path''  | latest revision on another branch  |
+ +--------------------+------------------------------------+
+
+Numbers
+-------
+
+Positive numbers denote revision numbers in the current branch. Revision
+numbers are labelled as "revno" in the output of `bzr log`.
+
+To display the log for the first ten revisions::
+    $ bzr log -r ..10
+
+Negative numbers count from the latest revision, -1 is the last committed
+revision.
+
+To display the log for the last ten revisions::
+
+    $ bzr log -r -10..
+
+revno, last
+-----------
+
+`revno:`''number'' is the same as ''number'', except that negative numbers are
+not allowed.
+
+`last:`''number'' is the same as -''number''. `last:1` means the last commited
+revision.
+
+revid
+-----
+
+`revid` allows specifying a an internal revision ID, as show by `bzr testament` and some other commands.
+
+For example::
+
+    $ bzr log -r revid:Matthieu.Moy@imag.fr-20051026185030-93c7cad63ee570df
+
+
+[[Anchor(before)]]
+before
+------
+
+`before:`''rev'' specifies the leftmost parent of ''rev'', that is the revision
+that appears before ''rev'' in the revision history, or the revision that was
+current when ''rev'' what comitted.
+
+''rev'' can be any revision specifier.
+
+For example::
+
+    $ bzr log -r before:before:4
+    ...
+    revno: 2
+    ...
+
+date
+----
+
+`date:`''value'' matches the first history entry after a given date, either at
+midnight or at a specified time.
+
+Legal values are:
+
+ * `yesterday`
+ * `today`
+ * `tomorrow`
+ * A `YYYY-MM-DD` format date.
+ * A `YYYY-MM-DD,HH:MM:SS` format date/time, seconds are optional (note the
+   comma)
+
+The proper way of saying "give me all the log entries for today" is::
+
+    $ bzr log -r date:yesterday..date:today
+
+Ancestor
+--------
+
+`ancestor:`''path'' specifies the common ancestor between the current branch, and a different branch. This is the same ancestor that would be used for merging purposes.
+
+''path'' may be the URL of a remote branch, or the file path to a local branch.
+
+For example, to see what changes were made on a branch since it was forked off ``../parent``: {{{
+$ bzr diff -r ancestor:../parent
+}}}
+
+Branch
+------
+
+`branch:`''path'' specifies the latest revision in another branch.
+
+''path'' may be the URL of a remote branch, or the file path to a local branch.
+
+For example, to get the differences between this and another branch:{{{
+$ bzr diff -r branch:http://example.com/bzr/foo.dev
+}}}

=== renamed file 'tutorial.txt' => 'doc/tutorial.txt'
--- tutorial.txt	2006-01-30 04:37:01 +0000
+++ doc/tutorial.txt	2006-03-14 16:22:52 +0000
@@ -2,8 +2,9 @@
 .. into HTML or text.  In the future we plan to extract the example commands
 .. and automatically test them.
 
-.. This text was previously on the wiki at http://bazaar.canonical.com/IntroductionToBzr
-.. but has been moved into the source tree so it can be kept in sync with
+.. This text was previously on the wiki at
+.. http://bazaar.canonical.com/IntroductionToBzr but has been moved into the
+.. source tree so it can be kept in sync with
 .. the source and possibly automatically checked.
 
 ==================
@@ -16,43 +17,105 @@
 Introduction
 ============
 
-If you are already familiar with decentralized revision control, then please feel free to skip ahead to "Introducing Yourself to Bazaar-NG". If, on the other hand, you are familiar with revision control but not decentralized revision control, then please start at "How DRCS is different." Otherwise, get some coffee or tea, get comfortable and get ready to catch up. 
+If you are already familiar with decentralized revision control, then
+please feel free to skip ahead to "Introducing Yourself to Bazaar-NG". If,
+on the other hand, you are familiar with revision control but not
+decentralized revision control, then please start at "How DRCS is
+different." Otherwise, get some coffee or tea, get comfortable and get
+ready to catch up. 
 
 The Purposes of Revision Control
 ================================
 
-Odds are that you have worked on some sort of textual data -- the sources to a program, web sites or the config files that Unix system administrators have to deal with in /etc. The chances are also good that you have made some sort of mistake that you deeply regretted. Perhaps you deleted the configuration file for your mailserver or perhaps mauled the source code for a pet project. Whatever happened, you have just deleted important information that you would desperately like to get back. If this has ever happened to you, then you are probably ready for Bazaar-NG.
-
-Revision control systems (which I'll henceforth call RCS) such as Bazaar-NG give you the ability to track changes for a directory by turning it into something slightly more complicated than a directory that we call a **branch**. The branch not only stores how the directory looks right now, but also how it looked at various points in the past. Then, when you do something you wish you hadn't, you can restore the directory to the way it looked at some point in the past.
-
-Revision control systems give users the ability to save changes to a branch by "committing a **revision**". The revision created is essentially a summary of the changes that were made since the last time the tree was saved. 
-
-These revisions have other uses as well. For example, one can comment revisions to record what the recent set of changes meant by providing an optional log message. Real life log messages include things like "Fixed the web template to close the table" and "Added sftp suppport. Fixes #595"
+Odds are that you have worked on some sort of textual data -- the sources
+to a program, web sites or the config files that Unix system administrators
+have to deal with in /etc. The chances are also good that you have made
+some sort of mistake that you deeply regretted. Perhaps you deleted the
+configuration file for your mailserver or perhaps mauled the source code
+for a pet project. Whatever happened, you have just deleted important
+information that you would desperately like to get back. If this has ever
+happened to you, then you are probably ready for Bazaar-NG.
+
+Revision control systems (which I'll henceforth call RCS) such as Bazaar-NG
+give you the ability to track changes for a directory by turning it into
+something slightly more complicated than a directory that we call a
+**branch**. The branch not only stores how the directory looks right now,
+but also how it looked at various points in the past. Then, when you do
+something you wish you hadn't, you can restore the directory to the way it
+looked at some point in the past.
+
+Revision control systems give users the ability to save changes to a branch
+by "committing a **revision**". The revision created is essentially a
+summary of the changes that were made since the last time the tree was
+saved. 
+
+These revisions have other uses as well. For example, one can comment
+revisions to record what the recent set of changes meant by providing an
+optional log message. Real life log messages include things like "Fixed the
+web template to close the table" and "Added sftp suppport. Fixes #595"
 	
-We keep these logs so that if later there is some sort of problem with sftp, we can figure out when the problem probably happened. 
+We keep these logs so that if later there is some sort of problem with
+sftp, we can figure out when the problem probably happened. 
 
 How DRCS is Different
 ---------------------
 
-Many Revision Control Systems (RCS) are stored on servers. If one wants to work on the code stored within an RCS, then one needs to connect to the server and "checkout" the code. Doing so gives one a directory in which a person can make changes and then commit. The RCS client then connects to the RCS server and stores the changes. This method is known as the centralized model. 
-
-The centralized model can have some drawbacks. A centralized RCS requires that one is able to connect to the server whenever one wants to do version control work. This can be a bit of a problem if your server on some other machine on the internet and you are not. Or, worse yet, you ''are'' on the internet but the server is missing!
-
-Decentralized Revision Control Systems (which I'll call DRCS after this point) deal with this problem by keeping branches on the same machine as the client. In Bazaar-NG's case, the branch is kept in the same place as the code that is being version controlled. This allows the user to save his changes (**commit**) whenever he wants -- even if he is offline. The user only needs internet access when he wants to access the changes in someone else's branch that are somewhere else.
+Many Revision Control Systems (RCS) are stored on servers. If one wants to
+work on the code stored within an RCS, then one needs to connect to the
+server and "checkout" the code. Doing so gives one a directory in which a
+person can make changes and then commit. The RCS client then connects to
+the RCS server and stores the changes. This method is known as the
+centralized model. 
+
+The centralized model can have some drawbacks. A centralized RCS requires
+that one is able to connect to the server whenever one wants to do version
+control work. This can be a bit of a problem if your server on some other
+machine on the internet and you are not. Or, worse yet, you ''are'' on the
+internet but the server is missing!
+
+Decentralized Revision Control Systems (which I'll call DRCS after this
+point) deal with this problem by keeping branches on the same machine as
+the client. In Bazaar-NG's case, the branch is kept in the same place as
+the code that is being version controlled. This allows the user to save his
+changes (**commit**) whenever he wants -- even if he is offline. The user
+only needs internet access when he wants to access the changes in someone
+else's branch that are somewhere else.
 
  
-A common requirement that many people have is the need to keep track of the changes for a directory such as file and subdirectory changes. Performing this tracking by hand is a awkward process that over time becomes unwieldy. That is, until one considers version control tools such as Bazaar-NG. These tools automate the process of storing data by creating a **revision** of the directory tree whenever the user asks. 
-
-Revision control software such as Bazaar-NG can do much more than just storage and performing undo.  For example, with Bazaar-NG developer can take the modifications in one branch of software and apply them to another, related, branch -- even if those changes exist in a branch owned by somebody else. This allows developers to cooperate without giving write access to repository.
-
-Bazaar-NG remembers the ''ancestry'' of a revision: the previous revisions that it is based upon.  A single revision may have more than one direct descendant, each with different changes, representing a divergence in the evolution of the tree. By branching, Bazaar-NG allows multiple people to cooperate on the evolution of a project, without all needing to work in strict lock-step.  Branching can be useful even for a single developer.
+A common requirement that many people have is the need to keep track of the
+changes for a directory such as file and subdirectory changes. Performing
+this tracking by hand is a awkward process that over time becomes unwieldy.
+That is, until one considers version control tools such as Bazaar-NG. These
+tools automate the process of storing data by creating a **revision** of
+the directory tree whenever the user asks. 
+
+Revision control software such as Bazaar-NG can do much more than just
+storage and performing undo.  For example, with Bazaar-NG developer can
+take the modifications in one branch of software and apply them to another,
+related, branch -- even if those changes exist in a branch owned by
+somebody else. This allows developers to cooperate without giving write
+access to repository.
+
+Bazaar-NG remembers the ''ancestry'' of a revision: the previous revisions
+that it is based upon.  A single revision may have more than one direct
+descendant, each with different changes, representing a divergence in the
+evolution of the tree. By branching, Bazaar-NG allows multiple people to
+cooperate on the evolution of a project, without all needing to work in
+strict lock-step.  Branching can be useful even for a single developer.
 
 Introducing yourself to Bazaar-NG
 =================================
 
-Bazaar-NG installs a single new command, **bzr**.  Everything else is a subcommand of this.  You can get some help with `bzr help`.  There will be more in the future.
+Bazaar-NG installs a single new command, **bzr**.  Everything else is a
+subcommand of this.  You can get some help with `bzr help`.  There will be
+more in the future.
 
-One function of a version control system is to keep track of who changed what.  In a decentralized system, that requires an identifier for each author that is globally unique.  Most people already have one of these: an email address. Bzr is smart enough to automatically generate an email address by looking up your username and hostname. If you don't like the guess that Bazaar-NG makes, then three options exist:
+One function of a version control system is to keep track of who changed
+what.  In a decentralized system, that requires an identifier for each
+author that is globally unique.  Most people already have one of these: an
+email address. Bzr is smart enough to automatically generate an email
+address by looking up your username and hostname. If you don't like the
+guess that Bazaar-NG makes, then three options exist:
 
  1. (**Bazaar-NG 0.6 and later**). Setting the email address in the
  ``~/.bazaar/bazaar.conf`` by adding the following lines. Please note that
@@ -69,12 +132,16 @@
     email=Your Name <email@isp.com>
  
  1. Overriding the two previous options by setting the global environment
- variable ``$BZREMAIL`` or ``$EMAIL`` (``$BZREMAIL`` will take precedence) to your full email address.
+    variable ``$BZREMAIL`` or ``$EMAIL`` (``$BZREMAIL`` will take precedence)
+    to your full email address.
 
 Creating a branch
 =================
 
-History is by default stored in the .bzr directory of the branch. There will be a facility to store it in a separate repository, which may be remote.  We create a new branch by running **bzr init** in an existing directory::
+History is by default stored in the .bzr directory of the branch. There
+will be a facility to store it in a separate repository, which may be
+remote.  We create a new branch by running **bzr init** in an existing
+directory::
 
     % mkdir tutorial
     % cd tutorial
@@ -88,7 +155,9 @@
     ./  ../  .bzr/
     %
 
-As for CVS, there are three classes of file: unknown, ignored, and versioned.  The **add** command makes a file versioned: that is, changes to it will be recorded by the system::
+As for CVS, there are three classes of file: unknown, ignored, and
+versioned.  The **add** command makes a file versioned: that is, changes to
+it will be recorded by the system::
 
     % echo 'hello world' > hello.txt
     % bzr status
@@ -101,14 +170,15 @@
     % bzr unknowns
 
 
-If you add the wrong file, simply use **bzr remove** to make it unversioned again.  This does not delete the working copy.
+If you add the wrong file, simply use **bzr remove** to make it unversioned
+again.  This does not delete the working copy.
 
 Branch locations
 ================
 
-All history is stored in a branch, which is just an on-disk directory containing control files.  There is no repository or database as used in svn or svk.
-
-  (There are proposals to add shared storage between related branches.)
+All history is stored in a branch, which is just an on-disk directory
+containing control files.  There is no repository or database as used in
+svn or svk.
 
 You'll usually refer to branches on your computer's filesystem just by
 giving the name of the directory containing the branch.  bzr also supports
@@ -116,12 +186,20 @@
 
     % bzr log http://bazaar-ng.org/bzr/bzr.dev/
 
-By installing bzr plugins you can also access branches over the sftp or rsync protocols.
+By installing bzr plugins you can also access branches over the sftp or
+rsync protocols.
 
 Reviewing changes
 =================
 
-Once you have completed some work, you will want to **commit** it to the version history.  It is good to commit fairly often: whenever you get a new feature working, fix a bug, or improve some code or documentation.  It's also a good practice to make sure that the code compiles and passes its test suite before committing, to make sure that every revision is a known-good state.  You can also review your changes, to make sure you're committing what you intend to, and as a chance to rethink your work before you permanently record it. 
+Once you have completed some work, you will want to **commit** it to the
+version history.  It is good to commit fairly often: whenever you get a new
+feature working, fix a bug, or improve some code or documentation.  It's
+also a good practice to make sure that the code compiles and passes its
+test suite before committing, to make sure that every revision is a
+known-good state.  You can also review your changes, to make sure you're
+committing what you intend to, and as a chance to rethink your work before
+you permanently record it. 
 
 Two bzr commands are particularly useful here: **status** and **diff**.  
 
@@ -135,12 +213,16 @@
     modified:
        foo
 
-By default **bzr status** hides "boring" files that are either unchanged or ignored.  To see them too, use the --all option.  The status command can optionally be given the name of some files or directories to check.
+By default **bzr status** hides "boring" files that are either unchanged or
+ignored.  To see them too, use the --all option.  The status command can
+optionally be given the name of some files or directories to check.
 
 bzr diff
 --------
 
-The **diff** command shows the full text of changes to all files as a standard unified diff.  This can be piped through many programs such as ''patch'', ''diffstat'', ''filterdiff'' and ''colordiff''::
+The **diff** command shows the full text of changes to all files as a
+standard unified diff.  This can be piped through many programs such as
+''patch'', ''diffstat'', ''filterdiff'' and ''colordiff''::
 
     % bzr diff
     *** added file 'hello.txt'
@@ -164,23 +246,36 @@
 Committing changes
 ==================
 
-When the working tree state is satisfactory, it can be **committed** to the branch, creating a new revision holding a snapshot of that state.  
+When the working tree state is satisfactory, it can be **committed** to the
+branch, creating a new revision holding a snapshot of that state.  
 
 bzr commit
 ----------
 
-The **commit** command takes a message describing the changes in the revision.  It also records your userid, the current time and timezone, and the inventory and contents of the tree.  The commit message is specified by the ''-m'' or ''--message'' option. You can enter a multi-line commit message; in most shells you can enter this just by leaving the quotes open at the end of the line.
+The **commit** command takes a message describing the changes in the
+revision.  It also records your userid, the current time and timezone, and
+the inventory and contents of the tree.  The commit message is specified by
+the ''-m'' or ''--message'' option. You can enter a multi-line commit
+message; in most shells you can enter this just by leaving the quotes open
+at the end of the line.
 
 ::
 
     % bzr commit -m "added my first file"
 
-You can also use the -F option to take the message from a file.  Some people like to make notes for a commit message while they work, then review the diff to make sure they did what they said they did.  (This file can also be useful when you pick up your work after a break.)
+You can also use the -F option to take the message from a file.  Some
+people like to make notes for a commit message while they work, then review
+the diff to make sure they did what they said they did.  (This file can
+also be useful when you pick up your work after a break.)
 
 Message from an editor
 ======================
 
-If you use neither the `-m` nor the `-F` option then bzr will open an editor for you to enter a message.  The editor to run is controlled by your `$EDITOR` environment variable or (Post Bazaar-NG 0.6) email setting in .  If you quit the editor without making any changes, the commit will be cancelled.
+If you use neither the `-m` nor the `-F` option then bzr will open an
+editor for you to enter a message.  The editor to run is controlled by your
+`$EDITOR` environment variable or (Post Bazaar-NG 0.6) email setting in .
+If you quit the editor without making any changes, the commit will be
+cancelled.
 
 Selective commit
 ----------------
@@ -199,14 +294,24 @@
 Removing uncommitted changes
 ============================
 
-If you've made some changes and don't want to keep them, use the **revert** command to go back to the previous head version.  It's a good idea to use **bzr diff** first to see what will be removed. By default the revert command reverts the whole tree; if file or directory names are given then only those ones will be affected. **revert** also clears the list of pending merges revisions.
+If you've made some changes and don't want to keep them, use the **revert**
+command to go back to the previous head version.  It's a good idea to use
+**bzr diff** first to see what will be removed. By default the revert
+command reverts the whole tree; if file or directory names are given then
+only those ones will be affected. **revert** also clears the list of
+pending merges revisions.
 
 Ignoring files
 ==============
 
-Many source trees contain some files that do not need to be versioned, such as editor backups, object or bytecode files, and built programs.  You can simply not add them, but then they'll always crop up as unknown files.  You can also tell bzr to ignore these files by adding them to a file called ''.bzrignore'' at the top of the tree.
+Many source trees contain some files that do not need to be versioned, such
+as editor backups, object or bytecode files, and built programs.  You can
+simply not add them, but then they'll always crop up as unknown files.  You
+can also tell bzr to ignore these files by adding them to a file called
+''.bzrignore'' at the top of the tree.
 
-This file contains a list of file wildcards (or "globs"), one per line.  Typical contents are like this::
+This file contains a list of file wildcards (or "globs"), one per line.
+Typical contents are like this::
 
     *.o
     *~
@@ -222,15 +327,20 @@
     ./config.h
     doc/*.html
 
-To get a list of which files are ignored and what pattern they matched, use ''bzr ignored''::
+To get a list of which files are ignored and what pattern they matched, use
+''bzr ignored''::
 
     % bzr ignored
     config.h                 ./config.h
     configure.in~            *~
 
-It is OK to have either an ignore pattern match a versioned file, or to add an ignored file.  Ignore patterns have no effect on versioned files; they only determine whether unversioned files are reported as unknown or ignored.
+It is OK to have either an ignore pattern match a versioned file, or to add
+an ignored file.  Ignore patterns have no effect on versioned files; they
+only determine whether unversioned files are reported as unknown or
+ignored.
 
-The ''.bzrignore'' file should normally be versioned, so that new copies of the branch see the same patterns::
+The ''.bzrignore'' file should normally be versioned, so that new copies of
+the branch see the same patterns::
 
     % bzr add .bzrignore
     % bzr commit -m "Add ignore patterns"
@@ -242,7 +352,9 @@
 bzr log
 -------
 
-The **bzr log** command shows a list of previous revisions. The **bzr log --forward** command does the same in chronological order to get most recent revisions printed at last.
+The **bzr log** command shows a list of previous revisions. The **bzr log
+--forward** command does the same in chronological order to get most recent
+revisions printed at last.
 
 As with bzr diff, bzr log supports the -r argument::
 
@@ -255,13 +367,15 @@
 Branch statistics
 =================
 
-The **bzr info** command shows some summary information about the working tree and the branch history.  
+The **bzr info** command shows some summary information about the working
+tree and the branch history.  
 
 
 Versioning directories
 ======================
 
-bzr versions files and directories in a way that can keep track of renames and intelligently merge them::
+bzr versions files and directories in a way that can keep track of renames
+and intelligently merge them::
 
     % mkdir src
     % echo 'int main() {}' > src/simple.c
@@ -277,9 +391,13 @@
 
 Deleting and removing files
 ===========================
-You can delete files or directories by just deleting them from the working directory.  This is a bit different to CVS, which requires that you also do **cvs remove**.
+You can delete files or directories by just deleting them from the working
+directory.  This is a bit different to CVS, which requires that you also do
+**cvs remove**.
 
-	**bzr remove** makes the file un-versioned, but does not delete the working copy.  This is useful when you add the wrong file, or decide that a file should actually not be versioned. 
+**bzr remove** makes the file un-versioned, but does not delete the working
+copy.  This is useful when you add the wrong file, or decide that a file
+should actually not be versioned. 
 
 ::
 
@@ -293,21 +411,47 @@
 
 If you remove the wrong file by accident, you can use **bzr revert** to restore it.
 
-
 Branching
 =========
 
-Often rather than starting your own project, you will want to submit a change to an existing project.  You can get a copy of an existing branch by copying its directory, expanding a tarball, or by a remote copy using something like rsync.  You can also use bzr to fetch a copy.  Because this new copy is potentially a new branch, the command is called *branch*::
+Often rather than starting your own project, you will want to submit a
+change to an existing project.  You can get a copy of an existing branch by
+copying its directory, expanding a tarball, or by a remote copy using
+something like rsync.  You can also use bzr to fetch a copy.  Because this
+new copy is potentially a new branch, the command is called *branch*::
 
     % bzr branch http://bazaar-ng.org/bzr/bzr.dev 
     % cd bzr.dev
 
-This copies down the complete history of this branch, so we can do all operations on it locally: log, annotate, making and merging branches.  There will be an option to get only part of the history if you wish.
+This copies down the complete history of this branch, so we can do all
+operations on it locally: log, annotate, making and merging branches.
+There will be an option to get only part of the history if you wish.
+
+Checkouts
+=========
+
+Another thing that gives you files to edit is a checkout. A checkout is
+always associated with another branch. One of the purposes of checkouts is
+to get multiple working trees for a branch. Another reason for checkouts is
+to get access to the files in a branch without keeping a full copy of the
+branch available locally. Getting a checkout looks like this::
+
+    % bzr checkout http://bazaar-ng.org/bzr/bzr.dev
+    % cd bzr.dev
+
+Checkouts have several advantages and drawbacks. A checkout does not have
+any RCS history as the history is stored in the branch for which a checkout
+is assocated with. This behaviour results in two general rules:
+
+ 1. checkouts take much less space than a full branch
+ 2. checkouts are much faster if the branch is on a local filesystem.
+
 
 Following upstream changes
 ==========================
 
-You can stay up-to-date with the parent branch by "pulling" in their changes::
+You can stay up-to-date with the parent branch by "pulling" in their changes
+::
 
     % bzr pull
 
@@ -320,24 +464,142 @@
 Merging from related branches
 =============================
 
-If two branches have diverged (both have unique changes) then **bzr merge** is the appropriate command to use. Merge will automatically calculate the changes that exist in the branch you're merging from that are not in your branch and attempt to apply them in your branch.
-
-::
+If two branches have diverged (both have unique changes) then **bzr merge**
+is the appropriate command to use. Merge will automatically calculate the
+changes that exist in the branch you're merging from that are not in your
+branch and attempt to apply them in your branch.  ::
 
   % bzr merge URL
 
 
-If there is a conflict during a merge, 3 files with the same basename are created. The filename of the common base is appended with .BASE, the filename of the file containing your changes is appended .THIS and the filename with the changes from the other tree is appended .OTHER.
-Using a program such as kdiff3, you can now comfortably merge them into one file. To commit you have to rename it to the original basename and delete the other two files. As long as there exist files with .BASE, .THIS or .OTHER the commit command will complain.
-
-[**TODO**: explain conflict markers within files]
+Conflicts during merge
+======================
+
+Sometimes two branches modify the same lines in the same files at the same
+time. The result of this collision is called a "conflict". These conflicts
+must be resolved by hand as Bazaar-NG can not tell which change you would
+prefer to keep. You are, however, provided with some information which
+makes the job easier for you to deal with.
+
+The first thing that Bazaar-NG does is to merge in the parts that it can.
+The parts that can not be merged are put into the file for you to decide
+what to do with.
+
+The second thing that Bazaar-NG does is to provide you with three extra
+files for each file that is conflicted. The names of these files are the
+same as the original filename with ".BASE", ".THIS" and ".OTHER" appended.
+Each of these files serves a different purpose:
+
++------------------+-----------------------------------------------------+
+| filename.BASE   | filename as it looked back when filename was         |
+|                 | identical in both branches.                          |
++-----------------+------------------------------------------------------+
+| filename.THIS   | The version of filename for this branch. All of the  |
+|                 | parts of the merge with the other branch that can be |
+|                 | merged from the other branch without conflicts are   |
+|                 | accepted. The parts which conflict are thrown away   |
++-----------------+------------------------------------------------------+
+| filename.OTHER  | The version of filename for the other branch. All of |
+|                 | parts of the merge from this branch that can be      |
+|                 | successfully merged are accepted. The parts of the   |
+|                 | merge which conflict are thrown away                 |
++-----------------+------------------------------------------------------+
+
+
+For example, imagine that you and another developer were working on on a
+simple branch that only contained hello.c. Both of you agree that saying 
+"Yo" to users is a little _too_ informal. Both of you also decide to fix
+the problem at the same time, but take slightly different approaches. You
+decide upon saying "Hi", while your compatriot decides upon a slightly more
+formal "Hello". You both make the respective change and commit. Then, you
+merge his change. The result would look something like this:
+
++----------------------+------------------------+
+|  hello.c.THIS        |    hello.c.THAT        |
++----------------------+------------------------+
+| | #include <stdio.h> | | #include <stdio.h>   |
+| | int                | | int                  |
+| | main()             | | main()               |
+| | {                  | | {                    |
+| |  printf("Hi");     | |   printf("Hello");   |
+| | }                  | | }                    |
+|                      |                        |
++----------------------+------------------------+
+|    hello.c.BASE      |       hello.c          |
++----------------------+------------------------+
+| | #include <stdio.h> | | #include <stdio.h>   |
+| | int                | | int                  |
+| | main()             | | main()               |
+| | {                  | | {                    |
+| |   printf("Yo");    | | <<<<<<< TREE         |
+| | }                  | |   printf("Hi");      |
+|                      | | =======              |
+|                      | |   printf("Hello");   |
+|                      | | <<<<<<< MERGE-SOURCE |
+|                      | | }                    |
+|                      |                        |
++----------------------+------------------------+
+
+Your job as a developer is to decide which better. A multitude of options
+exist for how to solve the conflict. Two of them are:
+
+  1. Decide whether you'd like hello.c.THIS, hello.c.THAT or hello.c.BASE.
+  Copy that one to hello.c.
+
+  1. edit hello.c and decide which part you wish to keep. Your solution
+  will be between the lines that say "<<<<<<< TREE" and "=======". His
+  solution will be between "=======" and "<<<<<<< MERGE-SOURCE").  Do not
+  forget to delete the markers too!
+
+Bazaar also tracks which files conflicted during merge to prevent you from
+accidentally committing the conflict markers to your branch. To tell
+Bazaar-NG that you have fixed one of the conflicted files, run::
+
+ % bzr resolve hello.c
+
+Using a program such as kdiff3, you can now comfortably merge them into one
+file. To commit you have to rename it to the original basename and delete
+the other two files. As long as there exist files with .BASE, .THIS or
+.OTHER the commit command will complain.
 
 
 Publishing your branch
 ======================
-You don't need a special server to publish a bzr branch, just a normal web server.  Just mirror the files to your server, including the .bzr directory.  One can push a branch (or the changes for a branch) by one of the following three methods:
-
- * Rsync:   rsync -avrz LOCALBRANCH  servername.com/this/directory/here
- * (Post 0.6): bzr push sftp://servername.com/this/directory/here (sftp://servername.com/this/directory/ must already exist)
- * The push plugin that comes with BzrTools
+
+You do not need a special server to publish a bzr branch. Generally
+speaking, one can push a branch via sftp to a directory that is served via
+apache. Bazaar-NG supports a variety of methods for reading and writing
+branches.
+
+Bazaar-NG can push branches via these methods::
+  1. sftp via ssh (the most common)
+  2. standard FTP
+  3. Any filesystem mounted via remote filesystem tools like NFS and Samba
+  4. The Canonical.com branch hosting service (via scoming soon)
+  5. Rsync (requires bzrtools plugin from http://bazaar-vcs.org/BzrTools)
+
+Bazaar-NG can also read branches via a variety of methods::
+
+  1. Standard http, (E.g. Apache)
+  2. rsync 
+  3. FTP 
+  3. SFTP
+
+The most common approach is to push a branch via sftp to a place that is
+served via SFTP. This usually looks something like::
+
+ * You have a branch in ~/somebranch
+ * You have a directory on /home/yourname/public_html on BigServer that
+   shows up as http://BigServer/~yourname
+
+In cases such as this, you'll usually perform the following commands to
+initially push your branch via rsync (which requires the bzrtools plugin)::
+
+ % cd somebranch/
+ % bzr push yourname@BigServer:public_html/somebranch/
+
+Other people can then access for your branch by doing the following::
+
+ % cd anotherbranch/
+ % bzr merge http://BigServer/~yourname/somebranch
 

=== added file 'doc/using_aliases.txt'
--- doc/using_aliases.txt	1970-01-01 00:00:00 +0000
+++ doc/using_aliases.txt	2006-03-14 16:22:52 +0000
@@ -0,0 +1,45 @@
+Command aliases are an eay way to customize the behaviour of Bazaar-NG. Aliases
+are an easy way to create shortcuts for commonly-typed commands, or to set
+defaults for commands.
+
+Command aliases can be defined in the `[ALIASES]` section of your
+**.bazaar/bazaar.conf** file. Aliases start with the alias name, then an
+equal sign, then a command fragment.  Here's an example ALIASES section:
+
+Examples
+========
+::
+    [ALIASES]
+    recentlog=log -r-3..-1
+    ll=log --line -r-10..-1
+    commit=commit --strict
+    diff=diff --diff-options -p
+
+Explanation of examples
+=======================
+
+ * The first alias makes a new 'recentlog' command that shows the logs for the
+last three revisions
+ * The `ll` alias shows the last 10 log entries in line format.
+ * the `commit` alias sets the default for commit to refuse to commit if new
+files in the tree are not recognized.
+ * the `diff` alias adds the coveted -p option to diff
+
+
+Rules for Aliases
+=================
+
+ * You can override parts of the options given in an alias by overriding it.
+   For example, if you run `lastlog -r-5..`, you will only get five
+   line-based log entries instead of 10.
+ * Aliases can override the standard behaviour of existing commands by giving
+   an alias name that is thesame as the orignal command. For example, default
+   commit is changed with `commit=commit --strict`.
+ * Aliases can not refer to other aliases. In other words making a
+   **lastlog** alias and referring to it with a ***ll*** alias will not work.
+
+This includes aliases that override standard commands
+
+ * Giving the `--no-aliases` to the bzr command will tell it to ignore aliases
+for that run. For example, running `bzr --no-aliases commit` will perform a
+standard commit instead not do a `commit --strict`.

